﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SpaceTransformationExample
{
    class Camera
    {
        public Vector2 Position { get; set; }
        public float Rotation { get; set; }
        public float Zoom { get; set; }

        private SpriteBatch mSpriteBatch;

        public Camera(SpriteBatch sb)
        {
            mSpriteBatch = sb;
            Position = new Vector2(Game1.SCREEN_WIDTH/ 2, Game1.SCREEN_HEIGHT/ 2);
            Rotation = 0.0f;
            Zoom = 1.0f;
        }

        public void Begin()
        {
            mSpriteBatch.Begin();
        }

        public void End()
        {
            mSpriteBatch.End();
        }
        public void Draw(WorldObject obj)
        {
            Vector2 objPosInCameraSpace = obj.Position;
            Vector2 objPosInScreenSpace = objPosInCameraSpace;

            mSpriteBatch.Draw(obj.Texture, objPosInScreenSpace, null, obj.color, obj.Rotation, obj.TextureOrigin, 1.0f, SpriteEffects.None, 0);

        }
    }
}
