﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SpaceTransformationExample
{
    class WorldObject
    {
        static Dictionary<Texture2D, Color[]> textureDataDictionary = null;

        public Texture2D Texture { get; set; }
        public Vector2 TextureOrigin { get; set; }
        public Vector2 Position;
        public float Rotation  { get; set; }
        public Color color;
        public Vector2 velocity;
        // Pointer to the data for the texture for this object
        public Color[] data;

        public Rectangle AABB()
        {
            // TODO 1:
            //  Calculate the AABB (Axis Aligned Bounding Box, the smallest possible
            //    rectangle aligned with the X and Y axes that completely contains the object).
            //  NOTE:  You need to look at TextureOrigin to ge this right!
            //
            // TODO 3: 
            //  Calculate the AABB for this object, considering the Rotation.
            //  For this you need to:
            //       Calculate the 4 corners of the object (the bounds of the AABB if it was *not* rotated)
            //       Rotate these 4 corners by the rotation
            //       Cacluate the smallest possible AABB that contains these points
            //           HINT:  Try using Min and Max on the x/y coordiantes of the rotated points ...
            //   To check if it worked, uncomment the section of the Update method for this object that handles rotation.

            return Rectangle.Empty;
        }


        public bool Collides(WorldObject other)
        {
            // Return true if we collide with other
            //
            // TODO 1:
            //   Calculate AABB for myself and other object, see if AABB's collide
            //
            // TODO 2:
            //   if the AABB's collide, check per-pixel to see if there are two 
            //   overlapping pixels with alpha value > 0.  The instane variable data is
            //   already filled in with the necessary data for the pixel.  data[x + y * Texture.Width].A 
            //   contains the alpha value for position x,y in the texture, measuring from the upper left
            //   point of the texture.
            //      (Note:  In your own game, you may want to check if if alphas are both exactly 255
            //       (collision only if there is no transparency at all), alphas both greater than 0
            //       (collision unless both pixels are completely tranparant) or both alphas greater than
            //       some intermediate value -- like 100 -- depending upon what your art is like and how
            //       you want collisions to work.  For now, checking if both alphas are > 0 is fine.)
            //
            // 
            //
            //  NOTE:  You will need the Position, TextureOrigin, Texture.Width and Texture.Height of *both* 
            //         objects to do these calculations correctly!
            //
            //  TODO 3: Handle AABB of rotated objects, see the AABB function skeleton above
            //
            //  TODO 4:
            //     Do pixel-perfect intersection with rotation.  For this you need to:
            //         For each pixel in object A:
            //            If A is non-transparent:  
            //                  Cacluate the position of this point in the object space of object B
            //                    Rotate then Translate using Object A's info to get to world space
            //                    Translate then Rotate (in opposite direction) using object B's info to get to local space
            //                    If this position is within Texture of object B, check to see if it is also non-transparent
            //

            return false;
        }

        public WorldObject(Texture2D texture)
        {
            if (WorldObject.textureDataDictionary == null)
            {
                WorldObject.textureDataDictionary = new Dictionary<Texture2D, Color[]>();
            }
            color = Color.White;
            Texture = texture;
            TextureOrigin = new Vector2(texture.Width, texture.Height) / 2;
            if (!WorldObject.textureDataDictionary.ContainsKey(texture))
            {
                data = new Color[texture.Width * texture.Height];
                Texture.GetData<Color>(data);
                WorldObject.textureDataDictionary.Add(texture, data);
            }
            else
            {
                data = WorldObject.textureDataDictionary[texture];
            }
            Rotation = 0;
        }


        public WorldObject(Texture2D texture, Vector2 initialPosition)
            : this(texture)
        {
            Position = initialPosition;
        }


        public void Update(GameTime gameTime)
        {
            Position += velocity * (float)gameTime.ElapsedGameTime.TotalSeconds;
            if (Position.X > Game1.SCREEN_WIDTH)
            {
                Position.X = Game1.SCREEN_WIDTH;
                velocity.X = -velocity.X;
            }
            if (Position.X < 0)
            {
                Position.X = 0;
                velocity.X = -velocity.X;
            }
            if (Position.Y > Game1.SCREEN_HEIGHT)
            {
                Position.Y = Game1.SCREEN_HEIGHT;
                velocity.Y = -velocity.Y;
            }
            if (Position.Y < 0)
            {
                Position.Y = 0;
                velocity.Y = -velocity.Y;
            }
            //Rotation = Rotation + (velocity.X - 15) * (float)gameTime.ElapsedGameTime.TotalSeconds / 10.0f;
            //if (Rotation > 2 * Math.PI)
            //{
            //    Rotation -= 2 * (float)Math.PI;
            //}
        }


    }
}
